<?php
function getPageTitle()
{
	return "IP Addresses";
}

function getPageContent()
{
global $time_frame, $year, $month, $day, $hour, $minute, $view, $limitPage, $limitNumber, $wpdb, $tablestattraq, $options;
$ip_address = st_getVar("ip_address", null);
$orderBy = st_getVar("orderBy", "ip_address DESC");
$startDate = date("Ymd");
$endDate = date("Ymd");
$betweenClause = "";
$date_format = "%Y-%m-%d %H:i";
if($time_frame == 4) // years
{
	$date_format = "%Y";
}
if($time_frame == 6) // months
{
	$startDate = st_createDateQueryString($year, 1, 1, 0, 0, 0);
	$endDate = st_createDateQueryString($year, 12, 31, 23, 59, 59);
	$betweenClause = " WHERE access_time BETWEEN '$startDate' AND '$endDate'";
	$date_format = "%Y-%m";
}
else if($time_frame == 8) // days
{
	$startDate = st_createDateQueryString($year, $month, 1, 0, 0, 0);
	$endDate = st_createDateQueryString($year, $month, 31, 23, 59, 59);
	$betweenClause = " WHERE access_time BETWEEN '$startDate' AND '$endDate'";
	$date_format = "%Y-%m-%d %H:%i";
}
else if($time_frame == 10) // hours
{
	$startDate = st_createDateQueryString($year, $month, $day, 0, 0, 0);
	$endDate = st_createDateQueryString($year, $month, $day, 23, 59, 59);
	$betweenClause = " WHERE access_time BETWEEN '$startDate' AND '$endDate'";
	$date_format = "%Y-%m-%d %H:00";
}
// minute
else if($time_frame == 12)
{
	$startDate = st_createDateQueryString($year, $month, $day, $hour, 0, 0);
	$endDate = st_createDateQueryString($year, $month, $day, $hour, 59, 59);
	$betweenClause = " WHERE access_time BETWEEN '$startDate' AND '$endDate'";
	$date_format = "%Y-%m-%d %H:i";
}

$totalHits = 0;
$maxHits = 0;
$rows = array();

if($ip_address != null)
	$betweenClause .= " AND ip_address = '{$ip_address}'";

$hideBots = ($options['ip_addresses_hide_bots'] == 'true' ? ' AND user_agent_type=0 ' : '' );
	
$sqlQuery = "SELECT DISTINCT ip_address, DATE_FORMAT(access_time,'$date_format') AS dd, browser, line_id, article_id FROM $tablestattraq $betweenClause $hideBots GROUP BY dd, ip_address ORDER BY $orderBy LIMIT $limitPage, $limitNumber";
$results = $wpdb->get_results($sqlQuery);
echo "<table cellpadding=\"4\">" .
	"<tr>" .
		"<th><a href=\"index.php?view=ip_address&time_frame=$time_frame&year=$year&month=$month&day=$day&hour=$hour&minute=$minute&date_format=$date_format&orderBy=" . ($orderBy == "dd DESC" ? "dd ASC" : "dd DESC" ) . "\">time</a></th>" .
		"<th><a href=\"index.php?view=ip_address&time_frame=$time_frame&year=$year&month=$month&day=$day&hour=$hour&minute=$minute&date_format=$date_format&orderBy=" . ($orderBy == "ip_address DESC" ? "ip_address ASC" : "ip_address DESC" ) . "\">ip</a></th>" . 
		"<th><a href=\"index.php?view=ip_address&time_frame=$time_frame&year=$year&month=$month&day=$day&hour=$hour&minute=$minute&date_format=$date_format&orderBy=" . ($orderBy == "browser DESC" ? "browser ASC" : "browser DESC" ) . "\">Browser</a></th>" .
		"<th>Article</th>" .
		"<th>Who Is</th>" .
		"<th>Info</th>" .
	"</tr>";
if($results)
{
	foreach($results as $row)
	{
		echo "<tr>\n\t" .
				"<td>{$row->dd}</td>" . // date
				"<td><a href=\"index.php?view=ip_address&time_frame=$time_frame&year=$year&month=$month&day=$day&hour=$hour&minute=$minute&date_format=$date_format&ip_address={$row->ip_address}\">{$row->ip_address}</a></td>" . // IP Address
				"<td>{$row->browser}</td>" . // Browser
				"<td>{$row->article_id}</td>" . // Article ID
				"<td><a href=\"http://ws.arin.net/cgi-bin/whois.pl?queryinput={$row->ip_address}\" target=\"_blank\">whois</a></td>" . 
				"<td><a href=\"javascript:var _x = window.open('access_detail.php?line_id={$row->line_id}','info','width=450,height=500,resizable=yes');\">info</a></td>" . 
			"</tr>\n";
	}
}
echo "</table>";
}
?>